/* Generated automatically by the program `genopinit'
   from the machine description file `md'.  */

#include "config.h"
#include "system.h"
#include "coretypes.h"
#include "tm.h"
#include "hash-set.h"
#include "machmode.h"
#include "vec.h"
#include "double-int.h"
#include "input.h"
#include "alias.h"
#include "symtab.h"
#include "wide-int.h"
#include "inchash.h"
#include "tree.h"
#include "varasm.h"
#include "stor-layout.h"
#include "calls.h"
#include "rtl.h"
#include "predict.h"
#include "tm_p.h"
#include "flags.h"
#include "insn-config.h"
#include "hashtab.h"
#include "hard-reg-set.h"
#include "function.h"
#include "statistics.h"
#include "real.h"
#include "fixed-value.h"
#include "expmed.h"
#include "dojump.h"
#include "explow.h"
#include "emit-rtl.h"
#include "stmt.h"
#include "expr.h"
#include "insn-codes.h"
#include "optabs.h"

struct optab_pat {
  unsigned scode;
  enum insn_code icode;
};

static const struct optab_pat pats[NUM_OPTAB_PATTERNS] = {
  { 0x011617, CODE_FOR_extendqihi2 },
  { 0x011618, CODE_FOR_extendqisi2 },
  { 0x011619, CODE_FOR_extendqidi2 },
  { 0x011718, CODE_FOR_extendhisi2 },
  { 0x011719, CODE_FOR_extendhidi2 },
  { 0x011819, CODE_FOR_extendsidi2 },
  { 0x013132, CODE_FOR_extendsfdf2 },
  { 0x023231, CODE_FOR_truncdfsf2 },
  { 0x031617, CODE_FOR_zero_extendqihi2 },
  { 0x031618, CODE_FOR_zero_extendqisi2 },
  { 0x031619, CODE_FOR_zero_extendqidi2 },
  { 0x031718, CODE_FOR_zero_extendhisi2 },
  { 0x031719, CODE_FOR_zero_extendhidi2 },
  { 0x031819, CODE_FOR_zero_extendsidi2 },
  { 0x045b45, CODE_FOR_fixv2sfv2si2 },
  { 0x045d48, CODE_FOR_fixv4sfv4si2 },
  { 0x045e49, CODE_FOR_fixv2dfv2di2 },
  { 0x055b45, CODE_FOR_fixunsv2sfv2si2 },
  { 0x055d48, CODE_FOR_fixunsv4sfv4si2 },
  { 0x055e49, CODE_FOR_fixunsv2dfv2di2 },
  { 0x061831, CODE_FOR_floatsisf2 },
  { 0x061832, CODE_FOR_floatsidf2 },
  { 0x061931, CODE_FOR_floatdisf2 },
  { 0x061932, CODE_FOR_floatdidf2 },
  { 0x06455b, CODE_FOR_floatv2siv2sf2 },
  { 0x06485d, CODE_FOR_floatv4siv4sf2 },
  { 0x06495e, CODE_FOR_floatv2div2df2 },
  { 0x071831, CODE_FOR_floatunssisf2 },
  { 0x071832, CODE_FOR_floatunssidf2 },
  { 0x071931, CODE_FOR_floatunsdisf2 },
  { 0x071932, CODE_FOR_floatunsdidf2 },
  { 0x07455b, CODE_FOR_floatunsv2siv2sf2 },
  { 0x07485d, CODE_FOR_floatunsv4siv4sf2 },
  { 0x07495e, CODE_FOR_floatunsv2div2df2 },
  { 0x093118, CODE_FOR_lroundsfsi2 },
  { 0x093119, CODE_FOR_lroundsfdi2 },
  { 0x093218, CODE_FOR_lrounddfsi2 },
  { 0x093219, CODE_FOR_lrounddfdi2 },
  { 0x095b45, CODE_FOR_lroundv2sfv2si2 },
  { 0x095d48, CODE_FOR_lroundv4sfv4si2 },
  { 0x095e49, CODE_FOR_lroundv2dfv2di2 },
  { 0x0a3118, CODE_FOR_lfloorsfsi2 },
  { 0x0a3119, CODE_FOR_lfloorsfdi2 },
  { 0x0a3218, CODE_FOR_lfloordfsi2 },
  { 0x0a3219, CODE_FOR_lfloordfdi2 },
  { 0x0a5b45, CODE_FOR_lfloorv2sfv2si2 },
  { 0x0a5d48, CODE_FOR_lfloorv4sfv4si2 },
  { 0x0a5e49, CODE_FOR_lfloorv2dfv2di2 },
  { 0x0b3118, CODE_FOR_lceilsfsi2 },
  { 0x0b3119, CODE_FOR_lceilsfdi2 },
  { 0x0b3218, CODE_FOR_lceildfsi2 },
  { 0x0b3219, CODE_FOR_lceildfdi2 },
  { 0x0b5b45, CODE_FOR_lceilv2sfv2si2 },
  { 0x0b5d48, CODE_FOR_lceilv4sfv4si2 },
  { 0x0b5e49, CODE_FOR_lceilv2dfv2di2 },
  { 0x103118, CODE_FOR_fix_truncsfsi2 },
  { 0x103119, CODE_FOR_fix_truncsfdi2 },
  { 0x103218, CODE_FOR_fix_truncdfsi2 },
  { 0x103219, CODE_FOR_fix_truncdfdi2 },
  { 0x105b45, CODE_FOR_fix_truncv2sfv2si2 },
  { 0x105d48, CODE_FOR_fix_truncv4sfv4si2 },
  { 0x105e49, CODE_FOR_fix_truncv2dfv2di2 },
  { 0x113118, CODE_FOR_fixuns_truncsfsi2 },
  { 0x113119, CODE_FOR_fixuns_truncsfdi2 },
  { 0x113218, CODE_FOR_fixuns_truncdfsi2 },
  { 0x113219, CODE_FOR_fixuns_truncdfdi2 },
  { 0x115b45, CODE_FOR_fixuns_truncv2sfv2si2 },
  { 0x115d48, CODE_FOR_fixuns_truncv4sfv4si2 },
  { 0x115e49, CODE_FOR_fixuns_truncv2dfv2di2 },
  { 0x121819, CODE_FOR_mulsidi3 },
  { 0x12191a, CODE_FOR_mulditi3 },
  { 0x131819, CODE_FOR_umulsidi3 },
  { 0x13191a, CODE_FOR_umulditi3 },
  { 0x151819, CODE_FOR_maddsidi4 },
  { 0x161819, CODE_FOR_umaddsidi4 },
  { 0x191819, CODE_FOR_msubsidi4 },
  { 0x1a1819, CODE_FOR_umsubsidi4 },
  { 0x1d461c, CODE_FOR_vec_load_lanesoiv16qi },
  { 0x1d461d, CODE_FOR_vec_load_lanesciv16qi },
  { 0x1d461e, CODE_FOR_vec_load_lanesxiv16qi },
  { 0x1d471c, CODE_FOR_vec_load_lanesoiv8hi },
  { 0x1d471d, CODE_FOR_vec_load_lanesciv8hi },
  { 0x1d471e, CODE_FOR_vec_load_lanesxiv8hi },
  { 0x1d481c, CODE_FOR_vec_load_lanesoiv4si },
  { 0x1d481d, CODE_FOR_vec_load_lanesciv4si },
  { 0x1d481e, CODE_FOR_vec_load_lanesxiv4si },
  { 0x1d491c, CODE_FOR_vec_load_lanesoiv2di },
  { 0x1d491d, CODE_FOR_vec_load_lanesciv2di },
  { 0x1d491e, CODE_FOR_vec_load_lanesxiv2di },
  { 0x1d5d1c, CODE_FOR_vec_load_lanesoiv4sf },
  { 0x1d5d1d, CODE_FOR_vec_load_lanesciv4sf },
  { 0x1d5d1e, CODE_FOR_vec_load_lanesxiv4sf },
  { 0x1d5e1c, CODE_FOR_vec_load_lanesoiv2df },
  { 0x1d5e1d, CODE_FOR_vec_load_lanesciv2df },
  { 0x1d5e1e, CODE_FOR_vec_load_lanesxiv2df },
  { 0x1e461c, CODE_FOR_vec_store_lanesoiv16qi },
  { 0x1e461d, CODE_FOR_vec_store_lanesciv16qi },
  { 0x1e461e, CODE_FOR_vec_store_lanesxiv16qi },
  { 0x1e471c, CODE_FOR_vec_store_lanesoiv8hi },
  { 0x1e471d, CODE_FOR_vec_store_lanesciv8hi },
  { 0x1e471e, CODE_FOR_vec_store_lanesxiv8hi },
  { 0x1e481c, CODE_FOR_vec_store_lanesoiv4si },
  { 0x1e481d, CODE_FOR_vec_store_lanesciv4si },
  { 0x1e481e, CODE_FOR_vec_store_lanesxiv4si },
  { 0x1e491c, CODE_FOR_vec_store_lanesoiv2di },
  { 0x1e491d, CODE_FOR_vec_store_lanesciv2di },
  { 0x1e491e, CODE_FOR_vec_store_lanesxiv2di },
  { 0x1e5d1c, CODE_FOR_vec_store_lanesoiv4sf },
  { 0x1e5d1d, CODE_FOR_vec_store_lanesciv4sf },
  { 0x1e5d1e, CODE_FOR_vec_store_lanesxiv4sf },
  { 0x1e5e1c, CODE_FOR_vec_store_lanesoiv2df },
  { 0x1e5e1d, CODE_FOR_vec_store_lanesciv2df },
  { 0x1e5e1e, CODE_FOR_vec_store_lanesxiv2df },
  { 0x1f4343, CODE_FOR_vcondv8qiv8qi },
  { 0x1f4444, CODE_FOR_vcondv4hiv4hi },
  { 0x1f4545, CODE_FOR_vcondv2siv2si },
  { 0x1f4646, CODE_FOR_vcondv16qiv16qi },
  { 0x1f4747, CODE_FOR_vcondv8hiv8hi },
  { 0x1f4848, CODE_FOR_vcondv4siv4si },
  { 0x1f4949, CODE_FOR_vcondv2div2di },
  { 0x1f5b45, CODE_FOR_vcondv2siv2sf },
  { 0x1f5b5b, CODE_FOR_vcondv2sfv2sf },
  { 0x1f5d48, CODE_FOR_vcondv4siv4sf },
  { 0x1f5d5d, CODE_FOR_vcondv4sfv4sf },
  { 0x1f5e49, CODE_FOR_vcondv2div2df },
  { 0x1f5e5e, CODE_FOR_vcondv2dfv2df },
  { 0x204343, CODE_FOR_vconduv8qiv8qi },
  { 0x204444, CODE_FOR_vconduv4hiv4hi },
  { 0x204545, CODE_FOR_vconduv2siv2si },
  { 0x204646, CODE_FOR_vconduv16qiv16qi },
  { 0x204747, CODE_FOR_vconduv8hiv8hi },
  { 0x204848, CODE_FOR_vconduv4siv4si },
  { 0x204949, CODE_FOR_vconduv2div2di },
  { 0x210018, CODE_FOR_addsi3 },
  { 0x210019, CODE_FOR_adddi3 },
  { 0x21001a, CODE_FOR_addti3 },
  { 0x210031, CODE_FOR_addsf3 },
  { 0x210032, CODE_FOR_adddf3 },
  { 0x210043, CODE_FOR_addv8qi3 },
  { 0x210044, CODE_FOR_addv4hi3 },
  { 0x210045, CODE_FOR_addv2si3 },
  { 0x210046, CODE_FOR_addv16qi3 },
  { 0x210047, CODE_FOR_addv8hi3 },
  { 0x210048, CODE_FOR_addv4si3 },
  { 0x210049, CODE_FOR_addv2di3 },
  { 0x21005b, CODE_FOR_addv2sf3 },
  { 0x21005d, CODE_FOR_addv4sf3 },
  { 0x21005e, CODE_FOR_addv2df3 },
  { 0x250018, CODE_FOR_subsi3 },
  { 0x250019, CODE_FOR_subdi3 },
  { 0x25001a, CODE_FOR_subti3 },
  { 0x250031, CODE_FOR_subsf3 },
  { 0x250032, CODE_FOR_subdf3 },
  { 0x250043, CODE_FOR_subv8qi3 },
  { 0x250044, CODE_FOR_subv4hi3 },
  { 0x250045, CODE_FOR_subv2si3 },
  { 0x250046, CODE_FOR_subv16qi3 },
  { 0x250047, CODE_FOR_subv8hi3 },
  { 0x250048, CODE_FOR_subv4si3 },
  { 0x250049, CODE_FOR_subv2di3 },
  { 0x25005b, CODE_FOR_subv2sf3 },
  { 0x25005d, CODE_FOR_subv4sf3 },
  { 0x25005e, CODE_FOR_subv2df3 },
  { 0x290018, CODE_FOR_mulsi3 },
  { 0x290019, CODE_FOR_muldi3 },
  { 0x29001a, CODE_FOR_multi3 },
  { 0x290031, CODE_FOR_mulsf3 },
  { 0x290032, CODE_FOR_muldf3 },
  { 0x290043, CODE_FOR_mulv8qi3 },
  { 0x290044, CODE_FOR_mulv4hi3 },
  { 0x290045, CODE_FOR_mulv2si3 },
  { 0x290046, CODE_FOR_mulv16qi3 },
  { 0x290047, CODE_FOR_mulv8hi3 },
  { 0x290048, CODE_FOR_mulv4si3 },
  { 0x29005b, CODE_FOR_mulv2sf3 },
  { 0x29005d, CODE_FOR_mulv4sf3 },
  { 0x29005e, CODE_FOR_mulv2df3 },
  { 0x2d0018, CODE_FOR_divsi3 },
  { 0x2d0019, CODE_FOR_divdi3 },
  { 0x2d0031, CODE_FOR_divsf3 },
  { 0x2d0032, CODE_FOR_divdf3 },
  { 0x2d005b, CODE_FOR_divv2sf3 },
  { 0x2d005d, CODE_FOR_divv4sf3 },
  { 0x2d005e, CODE_FOR_divv2df3 },
  { 0x300018, CODE_FOR_udivsi3 },
  { 0x300019, CODE_FOR_udivdi3 },
  { 0x36005b, CODE_FOR_ftruncv2sf2 },
  { 0x36005d, CODE_FOR_ftruncv4sf2 },
  { 0x36005e, CODE_FOR_ftruncv2df2 },
  { 0x370018, CODE_FOR_andsi3 },
  { 0x370019, CODE_FOR_anddi3 },
  { 0x370043, CODE_FOR_andv8qi3 },
  { 0x370044, CODE_FOR_andv4hi3 },
  { 0x370045, CODE_FOR_andv2si3 },
  { 0x370046, CODE_FOR_andv16qi3 },
  { 0x370047, CODE_FOR_andv8hi3 },
  { 0x370048, CODE_FOR_andv4si3 },
  { 0x370049, CODE_FOR_andv2di3 },
  { 0x380018, CODE_FOR_iorsi3 },
  { 0x380019, CODE_FOR_iordi3 },
  { 0x380043, CODE_FOR_iorv8qi3 },
  { 0x380044, CODE_FOR_iorv4hi3 },
  { 0x380045, CODE_FOR_iorv2si3 },
  { 0x380046, CODE_FOR_iorv16qi3 },
  { 0x380047, CODE_FOR_iorv8hi3 },
  { 0x380048, CODE_FOR_iorv4si3 },
  { 0x380049, CODE_FOR_iorv2di3 },
  { 0x390018, CODE_FOR_xorsi3 },
  { 0x390019, CODE_FOR_xordi3 },
  { 0x390043, CODE_FOR_xorv8qi3 },
  { 0x390044, CODE_FOR_xorv4hi3 },
  { 0x390045, CODE_FOR_xorv2si3 },
  { 0x390046, CODE_FOR_xorv16qi3 },
  { 0x390047, CODE_FOR_xorv8hi3 },
  { 0x390048, CODE_FOR_xorv4si3 },
  { 0x390049, CODE_FOR_xorv2di3 },
  { 0x3a0016, CODE_FOR_ashlqi3 },
  { 0x3a0017, CODE_FOR_ashlhi3 },
  { 0x3a0018, CODE_FOR_ashlsi3 },
  { 0x3a0019, CODE_FOR_ashldi3 },
  { 0x3a0043, CODE_FOR_ashlv8qi3 },
  { 0x3a0044, CODE_FOR_ashlv4hi3 },
  { 0x3a0045, CODE_FOR_ashlv2si3 },
  { 0x3a0046, CODE_FOR_ashlv16qi3 },
  { 0x3a0047, CODE_FOR_ashlv8hi3 },
  { 0x3a0048, CODE_FOR_ashlv4si3 },
  { 0x3a0049, CODE_FOR_ashlv2di3 },
  { 0x3d0018, CODE_FOR_ashrsi3 },
  { 0x3d0019, CODE_FOR_ashrdi3 },
  { 0x3d0043, CODE_FOR_ashrv8qi3 },
  { 0x3d0044, CODE_FOR_ashrv4hi3 },
  { 0x3d0045, CODE_FOR_ashrv2si3 },
  { 0x3d0046, CODE_FOR_ashrv16qi3 },
  { 0x3d0047, CODE_FOR_ashrv8hi3 },
  { 0x3d0048, CODE_FOR_ashrv4si3 },
  { 0x3d0049, CODE_FOR_ashrv2di3 },
  { 0x3e0018, CODE_FOR_lshrsi3 },
  { 0x3e0019, CODE_FOR_lshrdi3 },
  { 0x3e0043, CODE_FOR_lshrv8qi3 },
  { 0x3e0044, CODE_FOR_lshrv4hi3 },
  { 0x3e0045, CODE_FOR_lshrv2si3 },
  { 0x3e0046, CODE_FOR_lshrv16qi3 },
  { 0x3e0047, CODE_FOR_lshrv8hi3 },
  { 0x3e0048, CODE_FOR_lshrv4si3 },
  { 0x3e0049, CODE_FOR_lshrv2di3 },
  { 0x3f0018, CODE_FOR_rotlsi3 },
  { 0x3f0019, CODE_FOR_rotldi3 },
  { 0x400018, CODE_FOR_rotrsi3 },
  { 0x400019, CODE_FOR_rotrdi3 },
  { 0x410043, CODE_FOR_vashlv8qi3 },
  { 0x410044, CODE_FOR_vashlv4hi3 },
  { 0x410045, CODE_FOR_vashlv2si3 },
  { 0x410046, CODE_FOR_vashlv16qi3 },
  { 0x410047, CODE_FOR_vashlv8hi3 },
  { 0x410048, CODE_FOR_vashlv4si3 },
  { 0x410049, CODE_FOR_vashlv2di3 },
  { 0x420043, CODE_FOR_vashrv8qi3 },
  { 0x420044, CODE_FOR_vashrv4hi3 },
  { 0x420045, CODE_FOR_vashrv2si3 },
  { 0x420046, CODE_FOR_vashrv16qi3 },
  { 0x420047, CODE_FOR_vashrv8hi3 },
  { 0x420048, CODE_FOR_vashrv4si3 },
  { 0x430043, CODE_FOR_vlshrv8qi3 },
  { 0x430044, CODE_FOR_vlshrv4hi3 },
  { 0x430045, CODE_FOR_vlshrv2si3 },
  { 0x430046, CODE_FOR_vlshrv16qi3 },
  { 0x430047, CODE_FOR_vlshrv8hi3 },
  { 0x430048, CODE_FOR_vlshrv4si3 },
  { 0x460031, CODE_FOR_sminsf3 },
  { 0x460032, CODE_FOR_smindf3 },
  { 0x460043, CODE_FOR_sminv8qi3 },
  { 0x460044, CODE_FOR_sminv4hi3 },
  { 0x460045, CODE_FOR_sminv2si3 },
  { 0x460046, CODE_FOR_sminv16qi3 },
  { 0x460047, CODE_FOR_sminv8hi3 },
  { 0x460048, CODE_FOR_sminv4si3 },
  { 0x460049, CODE_FOR_sminv2di3 },
  { 0x46005b, CODE_FOR_sminv2sf3 },
  { 0x46005d, CODE_FOR_sminv4sf3 },
  { 0x46005e, CODE_FOR_sminv2df3 },
  { 0x470031, CODE_FOR_smaxsf3 },
  { 0x470032, CODE_FOR_smaxdf3 },
  { 0x470043, CODE_FOR_smaxv8qi3 },
  { 0x470044, CODE_FOR_smaxv4hi3 },
  { 0x470045, CODE_FOR_smaxv2si3 },
  { 0x470046, CODE_FOR_smaxv16qi3 },
  { 0x470047, CODE_FOR_smaxv8hi3 },
  { 0x470048, CODE_FOR_smaxv4si3 },
  { 0x470049, CODE_FOR_smaxv2di3 },
  { 0x47005b, CODE_FOR_smaxv2sf3 },
  { 0x47005d, CODE_FOR_smaxv4sf3 },
  { 0x47005e, CODE_FOR_smaxv2df3 },
  { 0x480043, CODE_FOR_uminv8qi3 },
  { 0x480044, CODE_FOR_uminv4hi3 },
  { 0x480045, CODE_FOR_uminv2si3 },
  { 0x480046, CODE_FOR_uminv16qi3 },
  { 0x480047, CODE_FOR_uminv8hi3 },
  { 0x480048, CODE_FOR_uminv4si3 },
  { 0x480049, CODE_FOR_uminv2di3 },
  { 0x490043, CODE_FOR_umaxv8qi3 },
  { 0x490044, CODE_FOR_umaxv4hi3 },
  { 0x490045, CODE_FOR_umaxv2si3 },
  { 0x490046, CODE_FOR_umaxv16qi3 },
  { 0x490047, CODE_FOR_umaxv8hi3 },
  { 0x490048, CODE_FOR_umaxv4si3 },
  { 0x490049, CODE_FOR_umaxv2di3 },
  { 0x4a0018, CODE_FOR_negsi2 },
  { 0x4a0019, CODE_FOR_negdi2 },
  { 0x4a0031, CODE_FOR_negsf2 },
  { 0x4a0032, CODE_FOR_negdf2 },
  { 0x4a0043, CODE_FOR_negv8qi2 },
  { 0x4a0044, CODE_FOR_negv4hi2 },
  { 0x4a0045, CODE_FOR_negv2si2 },
  { 0x4a0046, CODE_FOR_negv16qi2 },
  { 0x4a0047, CODE_FOR_negv8hi2 },
  { 0x4a0048, CODE_FOR_negv4si2 },
  { 0x4a0049, CODE_FOR_negv2di2 },
  { 0x4a005b, CODE_FOR_negv2sf2 },
  { 0x4a005d, CODE_FOR_negv4sf2 },
  { 0x4a005e, CODE_FOR_negv2df2 },
  { 0x4e0019, CODE_FOR_absdi2 },
  { 0x4e0031, CODE_FOR_abssf2 },
  { 0x4e0032, CODE_FOR_absdf2 },
  { 0x4e0043, CODE_FOR_absv8qi2 },
  { 0x4e0044, CODE_FOR_absv4hi2 },
  { 0x4e0045, CODE_FOR_absv2si2 },
  { 0x4e0046, CODE_FOR_absv16qi2 },
  { 0x4e0047, CODE_FOR_absv8hi2 },
  { 0x4e0048, CODE_FOR_absv4si2 },
  { 0x4e0049, CODE_FOR_absv2di2 },
  { 0x4e005b, CODE_FOR_absv2sf2 },
  { 0x4e005d, CODE_FOR_absv4sf2 },
  { 0x4e005e, CODE_FOR_absv2df2 },
  { 0x500018, CODE_FOR_one_cmplsi2 },
  { 0x500019, CODE_FOR_one_cmpldi2 },
  { 0x500043, CODE_FOR_one_cmplv8qi2 },
  { 0x500044, CODE_FOR_one_cmplv4hi2 },
  { 0x500045, CODE_FOR_one_cmplv2si2 },
  { 0x500046, CODE_FOR_one_cmplv16qi2 },
  { 0x500047, CODE_FOR_one_cmplv8hi2 },
  { 0x500048, CODE_FOR_one_cmplv4si2 },
  { 0x500049, CODE_FOR_one_cmplv2di2 },
  { 0x510017, CODE_FOR_bswaphi2 },
  { 0x510018, CODE_FOR_bswapsi2 },
  { 0x510019, CODE_FOR_bswapdi2 },
  { 0x510044, CODE_FOR_bswapv4hi2 },
  { 0x510045, CODE_FOR_bswapv2si2 },
  { 0x510047, CODE_FOR_bswapv8hi2 },
  { 0x510048, CODE_FOR_bswapv4si2 },
  { 0x510049, CODE_FOR_bswapv2di2 },
  { 0x520018, CODE_FOR_ffssi2 },
  { 0x520019, CODE_FOR_ffsdi2 },
  { 0x530018, CODE_FOR_clzsi2 },
  { 0x530019, CODE_FOR_clzdi2 },
  { 0x530043, CODE_FOR_clzv8qi2 },
  { 0x530044, CODE_FOR_clzv4hi2 },
  { 0x530045, CODE_FOR_clzv2si2 },
  { 0x530046, CODE_FOR_clzv16qi2 },
  { 0x530047, CODE_FOR_clzv8hi2 },
  { 0x530048, CODE_FOR_clzv4si2 },
  { 0x540018, CODE_FOR_ctzsi2 },
  { 0x540019, CODE_FOR_ctzdi2 },
  { 0x540045, CODE_FOR_ctzv2si2 },
  { 0x540048, CODE_FOR_ctzv4si2 },
  { 0x550018, CODE_FOR_clrsbsi2 },
  { 0x550019, CODE_FOR_clrsbdi2 },
  { 0x550043, CODE_FOR_clrsbv8qi2 },
  { 0x550044, CODE_FOR_clrsbv4hi2 },
  { 0x550045, CODE_FOR_clrsbv2si2 },
  { 0x550046, CODE_FOR_clrsbv16qi2 },
  { 0x550047, CODE_FOR_clrsbv8hi2 },
  { 0x550048, CODE_FOR_clrsbv4si2 },
  { 0x560043, CODE_FOR_popcountv8qi2 },
  { 0x560046, CODE_FOR_popcountv16qi2 },
  { 0x620031, CODE_FOR_sqrtsf2 },
  { 0x620032, CODE_FOR_sqrtdf2 },
  { 0x62005b, CODE_FOR_sqrtv2sf2 },
  { 0x62005d, CODE_FOR_sqrtv4sf2 },
  { 0x62005e, CODE_FOR_sqrtv2df2 },
  { 0x710016, CODE_FOR_movqi },
  { 0x710017, CODE_FOR_movhi },
  { 0x710018, CODE_FOR_movsi },
  { 0x710019, CODE_FOR_movdi },
  { 0x71001a, CODE_FOR_movti },
  { 0x71001c, CODE_FOR_movoi },
  { 0x71001d, CODE_FOR_movci },
  { 0x71001e, CODE_FOR_movxi },
  { 0x710031, CODE_FOR_movsf },
  { 0x710032, CODE_FOR_movdf },
  { 0x710033, CODE_FOR_movtf },
  { 0x710043, CODE_FOR_movv8qi },
  { 0x710044, CODE_FOR_movv4hi },
  { 0x710045, CODE_FOR_movv2si },
  { 0x710046, CODE_FOR_movv16qi },
  { 0x710047, CODE_FOR_movv8hi },
  { 0x710048, CODE_FOR_movv4si },
  { 0x710049, CODE_FOR_movv2di },
  { 0x71005b, CODE_FOR_movv2sf },
  { 0x71005d, CODE_FOR_movv4sf },
  { 0x71005e, CODE_FOR_movv2df },
  { 0x730043, CODE_FOR_movmisalignv8qi },
  { 0x730044, CODE_FOR_movmisalignv4hi },
  { 0x730045, CODE_FOR_movmisalignv2si },
  { 0x730046, CODE_FOR_movmisalignv16qi },
  { 0x730047, CODE_FOR_movmisalignv8hi },
  { 0x730048, CODE_FOR_movmisalignv4si },
  { 0x730049, CODE_FOR_movmisalignv2di },
  { 0x73005b, CODE_FOR_movmisalignv2sf },
  { 0x73005d, CODE_FOR_movmisalignv4sf },
  { 0x73005e, CODE_FOR_movmisalignv2df },
  { 0x750018, CODE_FOR_insvsi },
  { 0x750019, CODE_FOR_insvdi },
  { 0x7e0002, CODE_FOR_cbranchcc4 },
  { 0x7e0018, CODE_FOR_cbranchsi4 },
  { 0x7e0019, CODE_FOR_cbranchdi4 },
  { 0x7e0031, CODE_FOR_cbranchsf4 },
  { 0x7e0032, CODE_FOR_cbranchdf4 },
  { 0x800016, CODE_FOR_movqicc },
  { 0x800017, CODE_FOR_movhicc },
  { 0x800018, CODE_FOR_movsicc },
  { 0x800019, CODE_FOR_movdicc },
  { 0x800031, CODE_FOR_movsfcc },
  { 0x800032, CODE_FOR_movdfcc },
  { 0x810018, CODE_FOR_cmovsi6 },
  { 0x810019, CODE_FOR_cmovdi6 },
  { 0x810031, CODE_FOR_cmovsf6 },
  { 0x810032, CODE_FOR_cmovdf6 },
  { 0x820002, CODE_FOR_cstorecc4 },
  { 0x820018, CODE_FOR_cstoresi4 },
  { 0x820019, CODE_FOR_cstoredi4 },
  { 0x820031, CODE_FOR_cstoresf4 },
  { 0x820032, CODE_FOR_cstoredf4 },
  { 0x8a0019, CODE_FOR_smuldi3_highpart },
  { 0x8b0019, CODE_FOR_umuldi3_highpart },
  { 0x8f0019, CODE_FOR_movmemdi },
  { 0x920031, CODE_FOR_fmasf4 },
  { 0x920032, CODE_FOR_fmadf4 },
  { 0x92005b, CODE_FOR_fmav2sf4 },
  { 0x92005d, CODE_FOR_fmav4sf4 },
  { 0x92005e, CODE_FOR_fmav2df4 },
  { 0x930031, CODE_FOR_fmssf4 },
  { 0x930032, CODE_FOR_fmsdf4 },
  { 0x940031, CODE_FOR_fnmasf4 },
  { 0x940032, CODE_FOR_fnmadf4 },
  { 0x94005b, CODE_FOR_fnmav2sf4 },
  { 0x94005d, CODE_FOR_fnmav4sf4 },
  { 0x94005e, CODE_FOR_fnmav2df4 },
  { 0x950031, CODE_FOR_fnmssf4 },
  { 0x950032, CODE_FOR_fnmsdf4 },
  { 0x960031, CODE_FOR_rintsf2 },
  { 0x960032, CODE_FOR_rintdf2 },
  { 0x96005b, CODE_FOR_rintv2sf2 },
  { 0x96005d, CODE_FOR_rintv4sf2 },
  { 0x96005e, CODE_FOR_rintv2df2 },
  { 0x970031, CODE_FOR_roundsf2 },
  { 0x970032, CODE_FOR_rounddf2 },
  { 0x97005b, CODE_FOR_roundv2sf2 },
  { 0x97005d, CODE_FOR_roundv4sf2 },
  { 0x97005e, CODE_FOR_roundv2df2 },
  { 0x980031, CODE_FOR_floorsf2 },
  { 0x980032, CODE_FOR_floordf2 },
  { 0x98005b, CODE_FOR_floorv2sf2 },
  { 0x98005d, CODE_FOR_floorv4sf2 },
  { 0x98005e, CODE_FOR_floorv2df2 },
  { 0x990031, CODE_FOR_ceilsf2 },
  { 0x990032, CODE_FOR_ceildf2 },
  { 0x99005b, CODE_FOR_ceilv2sf2 },
  { 0x99005d, CODE_FOR_ceilv4sf2 },
  { 0x99005e, CODE_FOR_ceilv2df2 },
  { 0x9a0031, CODE_FOR_btruncsf2 },
  { 0x9a0032, CODE_FOR_btruncdf2 },
  { 0x9a005b, CODE_FOR_btruncv2sf2 },
  { 0x9a005d, CODE_FOR_btruncv4sf2 },
  { 0x9a005e, CODE_FOR_btruncv2df2 },
  { 0x9b0031, CODE_FOR_nearbyintsf2 },
  { 0x9b0032, CODE_FOR_nearbyintdf2 },
  { 0x9b005b, CODE_FOR_nearbyintv2sf2 },
  { 0x9b005d, CODE_FOR_nearbyintv4sf2 },
  { 0x9b005e, CODE_FOR_nearbyintv2df2 },
  { 0xb70043, CODE_FOR_reduc_smax_scal_v8qi },
  { 0xb70044, CODE_FOR_reduc_smax_scal_v4hi },
  { 0xb70045, CODE_FOR_reduc_smax_scal_v2si },
  { 0xb70046, CODE_FOR_reduc_smax_scal_v16qi },
  { 0xb70047, CODE_FOR_reduc_smax_scal_v8hi },
  { 0xb70048, CODE_FOR_reduc_smax_scal_v4si },
  { 0xb7005b, CODE_FOR_reduc_smax_scal_v2sf },
  { 0xb7005d, CODE_FOR_reduc_smax_scal_v4sf },
  { 0xb7005e, CODE_FOR_reduc_smax_scal_v2df },
  { 0xb80043, CODE_FOR_reduc_smin_scal_v8qi },
  { 0xb80044, CODE_FOR_reduc_smin_scal_v4hi },
  { 0xb80045, CODE_FOR_reduc_smin_scal_v2si },
  { 0xb80046, CODE_FOR_reduc_smin_scal_v16qi },
  { 0xb80047, CODE_FOR_reduc_smin_scal_v8hi },
  { 0xb80048, CODE_FOR_reduc_smin_scal_v4si },
  { 0xb8005b, CODE_FOR_reduc_smin_scal_v2sf },
  { 0xb8005d, CODE_FOR_reduc_smin_scal_v4sf },
  { 0xb8005e, CODE_FOR_reduc_smin_scal_v2df },
  { 0xb90043, CODE_FOR_reduc_plus_scal_v8qi },
  { 0xb90044, CODE_FOR_reduc_plus_scal_v4hi },
  { 0xb90045, CODE_FOR_reduc_plus_scal_v2si },
  { 0xb90046, CODE_FOR_reduc_plus_scal_v16qi },
  { 0xb90047, CODE_FOR_reduc_plus_scal_v8hi },
  { 0xb90048, CODE_FOR_reduc_plus_scal_v4si },
  { 0xb90049, CODE_FOR_reduc_plus_scal_v2di },
  { 0xb9005b, CODE_FOR_reduc_plus_scal_v2sf },
  { 0xb9005d, CODE_FOR_reduc_plus_scal_v4sf },
  { 0xb9005e, CODE_FOR_reduc_plus_scal_v2df },
  { 0xba0043, CODE_FOR_reduc_umax_scal_v8qi },
  { 0xba0044, CODE_FOR_reduc_umax_scal_v4hi },
  { 0xba0045, CODE_FOR_reduc_umax_scal_v2si },
  { 0xba0046, CODE_FOR_reduc_umax_scal_v16qi },
  { 0xba0047, CODE_FOR_reduc_umax_scal_v8hi },
  { 0xba0048, CODE_FOR_reduc_umax_scal_v4si },
  { 0xbb0043, CODE_FOR_reduc_umin_scal_v8qi },
  { 0xbb0044, CODE_FOR_reduc_umin_scal_v4hi },
  { 0xbb0045, CODE_FOR_reduc_umin_scal_v2si },
  { 0xbb0046, CODE_FOR_reduc_umin_scal_v16qi },
  { 0xbb0047, CODE_FOR_reduc_umin_scal_v8hi },
  { 0xbb0048, CODE_FOR_reduc_umin_scal_v4si },
  { 0xca0043, CODE_FOR_vec_extractv8qi },
  { 0xca0044, CODE_FOR_vec_extractv4hi },
  { 0xca0045, CODE_FOR_vec_extractv2si },
  { 0xca0046, CODE_FOR_vec_extractv16qi },
  { 0xca0047, CODE_FOR_vec_extractv8hi },
  { 0xca0048, CODE_FOR_vec_extractv4si },
  { 0xca0049, CODE_FOR_vec_extractv2di },
  { 0xca005b, CODE_FOR_vec_extractv2sf },
  { 0xca005d, CODE_FOR_vec_extractv4sf },
  { 0xca005e, CODE_FOR_vec_extractv2df },
  { 0xcb0043, CODE_FOR_vec_initv8qi },
  { 0xcb0044, CODE_FOR_vec_initv4hi },
  { 0xcb0045, CODE_FOR_vec_initv2si },
  { 0xcb0046, CODE_FOR_vec_initv16qi },
  { 0xcb0047, CODE_FOR_vec_initv8hi },
  { 0xcb0048, CODE_FOR_vec_initv4si },
  { 0xcb0049, CODE_FOR_vec_initv2di },
  { 0xcb005b, CODE_FOR_vec_initv2sf },
  { 0xcb005d, CODE_FOR_vec_initv4sf },
  { 0xcb005e, CODE_FOR_vec_initv2df },
  { 0xce0019, CODE_FOR_vec_pack_trunc_di },
  { 0xce0032, CODE_FOR_vec_pack_trunc_df },
  { 0xce0044, CODE_FOR_vec_pack_trunc_v4hi },
  { 0xce0045, CODE_FOR_vec_pack_trunc_v2si },
  { 0xce0047, CODE_FOR_vec_pack_trunc_v8hi },
  { 0xce0048, CODE_FOR_vec_pack_trunc_v4si },
  { 0xce0049, CODE_FOR_vec_pack_trunc_v2di },
  { 0xce005e, CODE_FOR_vec_pack_trunc_v2df },
  { 0xd10043, CODE_FOR_vec_perm_constv8qi },
  { 0xd10044, CODE_FOR_vec_perm_constv4hi },
  { 0xd10045, CODE_FOR_vec_perm_constv2si },
  { 0xd10046, CODE_FOR_vec_perm_constv16qi },
  { 0xd10047, CODE_FOR_vec_perm_constv8hi },
  { 0xd10048, CODE_FOR_vec_perm_constv4si },
  { 0xd10049, CODE_FOR_vec_perm_constv2di },
  { 0xd1005b, CODE_FOR_vec_perm_constv2sf },
  { 0xd1005d, CODE_FOR_vec_perm_constv4sf },
  { 0xd1005e, CODE_FOR_vec_perm_constv2df },
  { 0xd20043, CODE_FOR_vec_permv8qi },
  { 0xd20046, CODE_FOR_vec_permv16qi },
  { 0xd40043, CODE_FOR_vec_setv8qi },
  { 0xd40044, CODE_FOR_vec_setv4hi },
  { 0xd40045, CODE_FOR_vec_setv2si },
  { 0xd40046, CODE_FOR_vec_setv16qi },
  { 0xd40047, CODE_FOR_vec_setv8hi },
  { 0xd40048, CODE_FOR_vec_setv4si },
  { 0xd40049, CODE_FOR_vec_setv2di },
  { 0xd4005b, CODE_FOR_vec_setv2sf },
  { 0xd4005d, CODE_FOR_vec_setv4sf },
  { 0xd4005e, CODE_FOR_vec_setv2df },
  { 0xd50043, CODE_FOR_vec_shr_v8qi },
  { 0xd50044, CODE_FOR_vec_shr_v4hi },
  { 0xd50045, CODE_FOR_vec_shr_v2si },
  { 0xd5005b, CODE_FOR_vec_shr_v2sf },
  { 0xd80046, CODE_FOR_vec_unpacks_hi_v16qi },
  { 0xd80047, CODE_FOR_vec_unpacks_hi_v8hi },
  { 0xd80048, CODE_FOR_vec_unpacks_hi_v4si },
  { 0xd8005d, CODE_FOR_vec_unpacks_hi_v4sf },
  { 0xd90046, CODE_FOR_vec_unpacks_lo_v16qi },
  { 0xd90047, CODE_FOR_vec_unpacks_lo_v8hi },
  { 0xd90048, CODE_FOR_vec_unpacks_lo_v4si },
  { 0xd9005d, CODE_FOR_vec_unpacks_lo_v4sf },
  { 0xdc0046, CODE_FOR_vec_unpacku_hi_v16qi },
  { 0xdc0047, CODE_FOR_vec_unpacku_hi_v8hi },
  { 0xdc0048, CODE_FOR_vec_unpacku_hi_v4si },
  { 0xdd0046, CODE_FOR_vec_unpacku_lo_v16qi },
  { 0xdd0047, CODE_FOR_vec_unpacku_lo_v8hi },
  { 0xdd0048, CODE_FOR_vec_unpacku_lo_v4si },
  { 0xdf0046, CODE_FOR_vec_widen_smult_hi_v16qi },
  { 0xdf0047, CODE_FOR_vec_widen_smult_hi_v8hi },
  { 0xdf0048, CODE_FOR_vec_widen_smult_hi_v4si },
  { 0xe00046, CODE_FOR_vec_widen_smult_lo_v16qi },
  { 0xe00047, CODE_FOR_vec_widen_smult_lo_v8hi },
  { 0xe00048, CODE_FOR_vec_widen_smult_lo_v4si },
  { 0xe50046, CODE_FOR_vec_widen_umult_hi_v16qi },
  { 0xe50047, CODE_FOR_vec_widen_umult_hi_v8hi },
  { 0xe50048, CODE_FOR_vec_widen_umult_hi_v4si },
  { 0xe60046, CODE_FOR_vec_widen_umult_lo_v16qi },
  { 0xe60047, CODE_FOR_vec_widen_umult_lo_v8hi },
  { 0xe60048, CODE_FOR_vec_widen_umult_lo_v4si },
  { 0xf10016, CODE_FOR_atomic_add_fetchqi },
  { 0xf10017, CODE_FOR_atomic_add_fetchhi },
  { 0xf10018, CODE_FOR_atomic_add_fetchsi },
  { 0xf10019, CODE_FOR_atomic_add_fetchdi },
  { 0xf20016, CODE_FOR_atomic_addqi },
  { 0xf20017, CODE_FOR_atomic_addhi },
  { 0xf20018, CODE_FOR_atomic_addsi },
  { 0xf20019, CODE_FOR_atomic_adddi },
  { 0xf30016, CODE_FOR_atomic_and_fetchqi },
  { 0xf30017, CODE_FOR_atomic_and_fetchhi },
  { 0xf30018, CODE_FOR_atomic_and_fetchsi },
  { 0xf30019, CODE_FOR_atomic_and_fetchdi },
  { 0xf40016, CODE_FOR_atomic_andqi },
  { 0xf40017, CODE_FOR_atomic_andhi },
  { 0xf40018, CODE_FOR_atomic_andsi },
  { 0xf40019, CODE_FOR_atomic_anddi },
  { 0xf50016, CODE_FOR_atomic_compare_and_swapqi },
  { 0xf50017, CODE_FOR_atomic_compare_and_swaphi },
  { 0xf50018, CODE_FOR_atomic_compare_and_swapsi },
  { 0xf50019, CODE_FOR_atomic_compare_and_swapdi },
  { 0xf60016, CODE_FOR_atomic_exchangeqi },
  { 0xf60017, CODE_FOR_atomic_exchangehi },
  { 0xf60018, CODE_FOR_atomic_exchangesi },
  { 0xf60019, CODE_FOR_atomic_exchangedi },
  { 0xf70016, CODE_FOR_atomic_fetch_addqi },
  { 0xf70017, CODE_FOR_atomic_fetch_addhi },
  { 0xf70018, CODE_FOR_atomic_fetch_addsi },
  { 0xf70019, CODE_FOR_atomic_fetch_adddi },
  { 0xf80016, CODE_FOR_atomic_fetch_andqi },
  { 0xf80017, CODE_FOR_atomic_fetch_andhi },
  { 0xf80018, CODE_FOR_atomic_fetch_andsi },
  { 0xf80019, CODE_FOR_atomic_fetch_anddi },
  { 0xf90016, CODE_FOR_atomic_fetch_nandqi },
  { 0xf90017, CODE_FOR_atomic_fetch_nandhi },
  { 0xf90018, CODE_FOR_atomic_fetch_nandsi },
  { 0xf90019, CODE_FOR_atomic_fetch_nanddi },
  { 0xfa0016, CODE_FOR_atomic_fetch_orqi },
  { 0xfa0017, CODE_FOR_atomic_fetch_orhi },
  { 0xfa0018, CODE_FOR_atomic_fetch_orsi },
  { 0xfa0019, CODE_FOR_atomic_fetch_ordi },
  { 0xfb0016, CODE_FOR_atomic_fetch_subqi },
  { 0xfb0017, CODE_FOR_atomic_fetch_subhi },
  { 0xfb0018, CODE_FOR_atomic_fetch_subsi },
  { 0xfb0019, CODE_FOR_atomic_fetch_subdi },
  { 0xfc0016, CODE_FOR_atomic_fetch_xorqi },
  { 0xfc0017, CODE_FOR_atomic_fetch_xorhi },
  { 0xfc0018, CODE_FOR_atomic_fetch_xorsi },
  { 0xfc0019, CODE_FOR_atomic_fetch_xordi },
  { 0xfd0016, CODE_FOR_atomic_loadqi },
  { 0xfd0017, CODE_FOR_atomic_loadhi },
  { 0xfd0018, CODE_FOR_atomic_loadsi },
  { 0xfd0019, CODE_FOR_atomic_loaddi },
  { 0xfe0016, CODE_FOR_atomic_nand_fetchqi },
  { 0xfe0017, CODE_FOR_atomic_nand_fetchhi },
  { 0xfe0018, CODE_FOR_atomic_nand_fetchsi },
  { 0xfe0019, CODE_FOR_atomic_nand_fetchdi },
  { 0xff0016, CODE_FOR_atomic_nandqi },
  { 0xff0017, CODE_FOR_atomic_nandhi },
  { 0xff0018, CODE_FOR_atomic_nandsi },
  { 0xff0019, CODE_FOR_atomic_nanddi },
  { 0x1000016, CODE_FOR_atomic_or_fetchqi },
  { 0x1000017, CODE_FOR_atomic_or_fetchhi },
  { 0x1000018, CODE_FOR_atomic_or_fetchsi },
  { 0x1000019, CODE_FOR_atomic_or_fetchdi },
  { 0x1010016, CODE_FOR_atomic_orqi },
  { 0x1010017, CODE_FOR_atomic_orhi },
  { 0x1010018, CODE_FOR_atomic_orsi },
  { 0x1010019, CODE_FOR_atomic_ordi },
  { 0x1020016, CODE_FOR_atomic_storeqi },
  { 0x1020017, CODE_FOR_atomic_storehi },
  { 0x1020018, CODE_FOR_atomic_storesi },
  { 0x1020019, CODE_FOR_atomic_storedi },
  { 0x1030016, CODE_FOR_atomic_sub_fetchqi },
  { 0x1030017, CODE_FOR_atomic_sub_fetchhi },
  { 0x1030018, CODE_FOR_atomic_sub_fetchsi },
  { 0x1030019, CODE_FOR_atomic_sub_fetchdi },
  { 0x1040016, CODE_FOR_atomic_subqi },
  { 0x1040017, CODE_FOR_atomic_subhi },
  { 0x1040018, CODE_FOR_atomic_subsi },
  { 0x1040019, CODE_FOR_atomic_subdi },
  { 0x1050016, CODE_FOR_atomic_xor_fetchqi },
  { 0x1050017, CODE_FOR_atomic_xor_fetchhi },
  { 0x1050018, CODE_FOR_atomic_xor_fetchsi },
  { 0x1050019, CODE_FOR_atomic_xor_fetchdi },
  { 0x1060016, CODE_FOR_atomic_xorqi },
  { 0x1060017, CODE_FOR_atomic_xorhi },
  { 0x1060018, CODE_FOR_atomic_xorsi },
  { 0x1060019, CODE_FOR_atomic_xordi },
  { 0x1070019, CODE_FOR_get_thread_pointerdi },
};

void
init_all_optabs (struct target_optabs *optabs)
{
  bool *ena = optabs->pat_enable;
  ena[0] = HAVE_extendqihi2;
  ena[1] = HAVE_extendqisi2;
  ena[2] = HAVE_extendqidi2;
  ena[3] = HAVE_extendhisi2;
  ena[4] = HAVE_extendhidi2;
  ena[5] = HAVE_extendsidi2;
  ena[6] = HAVE_extendsfdf2;
  ena[7] = HAVE_truncdfsf2;
  ena[8] = HAVE_zero_extendqihi2;
  ena[9] = HAVE_zero_extendqisi2;
  ena[10] = HAVE_zero_extendqidi2;
  ena[11] = HAVE_zero_extendhisi2;
  ena[12] = HAVE_zero_extendhidi2;
  ena[13] = HAVE_zero_extendsidi2;
  ena[14] = HAVE_fixv2sfv2si2;
  ena[15] = HAVE_fixv4sfv4si2;
  ena[16] = HAVE_fixv2dfv2di2;
  ena[17] = HAVE_fixunsv2sfv2si2;
  ena[18] = HAVE_fixunsv4sfv4si2;
  ena[19] = HAVE_fixunsv2dfv2di2;
  ena[20] = HAVE_floatsisf2;
  ena[21] = HAVE_floatsidf2;
  ena[22] = HAVE_floatdisf2;
  ena[23] = HAVE_floatdidf2;
  ena[24] = HAVE_floatv2siv2sf2;
  ena[25] = HAVE_floatv4siv4sf2;
  ena[26] = HAVE_floatv2div2df2;
  ena[27] = HAVE_floatunssisf2;
  ena[28] = HAVE_floatunssidf2;
  ena[29] = HAVE_floatunsdisf2;
  ena[30] = HAVE_floatunsdidf2;
  ena[31] = HAVE_floatunsv2siv2sf2;
  ena[32] = HAVE_floatunsv4siv4sf2;
  ena[33] = HAVE_floatunsv2div2df2;
  ena[34] = HAVE_lroundsfsi2;
  ena[35] = HAVE_lroundsfdi2;
  ena[36] = HAVE_lrounddfsi2;
  ena[37] = HAVE_lrounddfdi2;
  ena[38] = HAVE_lroundv2sfv2si2;
  ena[39] = HAVE_lroundv4sfv4si2;
  ena[40] = HAVE_lroundv2dfv2di2;
  ena[41] = HAVE_lfloorsfsi2;
  ena[42] = HAVE_lfloorsfdi2;
  ena[43] = HAVE_lfloordfsi2;
  ena[44] = HAVE_lfloordfdi2;
  ena[45] = HAVE_lfloorv2sfv2si2;
  ena[46] = HAVE_lfloorv4sfv4si2;
  ena[47] = HAVE_lfloorv2dfv2di2;
  ena[48] = HAVE_lceilsfsi2;
  ena[49] = HAVE_lceilsfdi2;
  ena[50] = HAVE_lceildfsi2;
  ena[51] = HAVE_lceildfdi2;
  ena[52] = HAVE_lceilv2sfv2si2;
  ena[53] = HAVE_lceilv4sfv4si2;
  ena[54] = HAVE_lceilv2dfv2di2;
  ena[55] = HAVE_fix_truncsfsi2;
  ena[56] = HAVE_fix_truncsfdi2;
  ena[57] = HAVE_fix_truncdfsi2;
  ena[58] = HAVE_fix_truncdfdi2;
  ena[59] = HAVE_fix_truncv2sfv2si2;
  ena[60] = HAVE_fix_truncv4sfv4si2;
  ena[61] = HAVE_fix_truncv2dfv2di2;
  ena[62] = HAVE_fixuns_truncsfsi2;
  ena[63] = HAVE_fixuns_truncsfdi2;
  ena[64] = HAVE_fixuns_truncdfsi2;
  ena[65] = HAVE_fixuns_truncdfdi2;
  ena[66] = HAVE_fixuns_truncv2sfv2si2;
  ena[67] = HAVE_fixuns_truncv4sfv4si2;
  ena[68] = HAVE_fixuns_truncv2dfv2di2;
  ena[69] = HAVE_mulsidi3;
  ena[70] = HAVE_mulditi3;
  ena[71] = HAVE_umulsidi3;
  ena[72] = HAVE_umulditi3;
  ena[73] = HAVE_maddsidi4;
  ena[74] = HAVE_umaddsidi4;
  ena[75] = HAVE_msubsidi4;
  ena[76] = HAVE_umsubsidi4;
  ena[77] = HAVE_vec_load_lanesoiv16qi;
  ena[78] = HAVE_vec_load_lanesciv16qi;
  ena[79] = HAVE_vec_load_lanesxiv16qi;
  ena[80] = HAVE_vec_load_lanesoiv8hi;
  ena[81] = HAVE_vec_load_lanesciv8hi;
  ena[82] = HAVE_vec_load_lanesxiv8hi;
  ena[83] = HAVE_vec_load_lanesoiv4si;
  ena[84] = HAVE_vec_load_lanesciv4si;
  ena[85] = HAVE_vec_load_lanesxiv4si;
  ena[86] = HAVE_vec_load_lanesoiv2di;
  ena[87] = HAVE_vec_load_lanesciv2di;
  ena[88] = HAVE_vec_load_lanesxiv2di;
  ena[89] = HAVE_vec_load_lanesoiv4sf;
  ena[90] = HAVE_vec_load_lanesciv4sf;
  ena[91] = HAVE_vec_load_lanesxiv4sf;
  ena[92] = HAVE_vec_load_lanesoiv2df;
  ena[93] = HAVE_vec_load_lanesciv2df;
  ena[94] = HAVE_vec_load_lanesxiv2df;
  ena[95] = HAVE_vec_store_lanesoiv16qi;
  ena[96] = HAVE_vec_store_lanesciv16qi;
  ena[97] = HAVE_vec_store_lanesxiv16qi;
  ena[98] = HAVE_vec_store_lanesoiv8hi;
  ena[99] = HAVE_vec_store_lanesciv8hi;
  ena[100] = HAVE_vec_store_lanesxiv8hi;
  ena[101] = HAVE_vec_store_lanesoiv4si;
  ena[102] = HAVE_vec_store_lanesciv4si;
  ena[103] = HAVE_vec_store_lanesxiv4si;
  ena[104] = HAVE_vec_store_lanesoiv2di;
  ena[105] = HAVE_vec_store_lanesciv2di;
  ena[106] = HAVE_vec_store_lanesxiv2di;
  ena[107] = HAVE_vec_store_lanesoiv4sf;
  ena[108] = HAVE_vec_store_lanesciv4sf;
  ena[109] = HAVE_vec_store_lanesxiv4sf;
  ena[110] = HAVE_vec_store_lanesoiv2df;
  ena[111] = HAVE_vec_store_lanesciv2df;
  ena[112] = HAVE_vec_store_lanesxiv2df;
  ena[113] = HAVE_vcondv8qiv8qi;
  ena[114] = HAVE_vcondv4hiv4hi;
  ena[115] = HAVE_vcondv2siv2si;
  ena[116] = HAVE_vcondv16qiv16qi;
  ena[117] = HAVE_vcondv8hiv8hi;
  ena[118] = HAVE_vcondv4siv4si;
  ena[119] = HAVE_vcondv2div2di;
  ena[120] = HAVE_vcondv2siv2sf;
  ena[121] = HAVE_vcondv2sfv2sf;
  ena[122] = HAVE_vcondv4siv4sf;
  ena[123] = HAVE_vcondv4sfv4sf;
  ena[124] = HAVE_vcondv2div2df;
  ena[125] = HAVE_vcondv2dfv2df;
  ena[126] = HAVE_vconduv8qiv8qi;
  ena[127] = HAVE_vconduv4hiv4hi;
  ena[128] = HAVE_vconduv2siv2si;
  ena[129] = HAVE_vconduv16qiv16qi;
  ena[130] = HAVE_vconduv8hiv8hi;
  ena[131] = HAVE_vconduv4siv4si;
  ena[132] = HAVE_vconduv2div2di;
  ena[133] = HAVE_addsi3;
  ena[134] = HAVE_adddi3;
  ena[135] = HAVE_addti3;
  ena[136] = HAVE_addsf3;
  ena[137] = HAVE_adddf3;
  ena[138] = HAVE_addv8qi3;
  ena[139] = HAVE_addv4hi3;
  ena[140] = HAVE_addv2si3;
  ena[141] = HAVE_addv16qi3;
  ena[142] = HAVE_addv8hi3;
  ena[143] = HAVE_addv4si3;
  ena[144] = HAVE_addv2di3;
  ena[145] = HAVE_addv2sf3;
  ena[146] = HAVE_addv4sf3;
  ena[147] = HAVE_addv2df3;
  ena[148] = HAVE_subsi3;
  ena[149] = HAVE_subdi3;
  ena[150] = HAVE_subti3;
  ena[151] = HAVE_subsf3;
  ena[152] = HAVE_subdf3;
  ena[153] = HAVE_subv8qi3;
  ena[154] = HAVE_subv4hi3;
  ena[155] = HAVE_subv2si3;
  ena[156] = HAVE_subv16qi3;
  ena[157] = HAVE_subv8hi3;
  ena[158] = HAVE_subv4si3;
  ena[159] = HAVE_subv2di3;
  ena[160] = HAVE_subv2sf3;
  ena[161] = HAVE_subv4sf3;
  ena[162] = HAVE_subv2df3;
  ena[163] = HAVE_mulsi3;
  ena[164] = HAVE_muldi3;
  ena[165] = HAVE_multi3;
  ena[166] = HAVE_mulsf3;
  ena[167] = HAVE_muldf3;
  ena[168] = HAVE_mulv8qi3;
  ena[169] = HAVE_mulv4hi3;
  ena[170] = HAVE_mulv2si3;
  ena[171] = HAVE_mulv16qi3;
  ena[172] = HAVE_mulv8hi3;
  ena[173] = HAVE_mulv4si3;
  ena[174] = HAVE_mulv2sf3;
  ena[175] = HAVE_mulv4sf3;
  ena[176] = HAVE_mulv2df3;
  ena[177] = HAVE_divsi3;
  ena[178] = HAVE_divdi3;
  ena[179] = HAVE_divsf3;
  ena[180] = HAVE_divdf3;
  ena[181] = HAVE_divv2sf3;
  ena[182] = HAVE_divv4sf3;
  ena[183] = HAVE_divv2df3;
  ena[184] = HAVE_udivsi3;
  ena[185] = HAVE_udivdi3;
  ena[186] = HAVE_ftruncv2sf2;
  ena[187] = HAVE_ftruncv4sf2;
  ena[188] = HAVE_ftruncv2df2;
  ena[189] = HAVE_andsi3;
  ena[190] = HAVE_anddi3;
  ena[191] = HAVE_andv8qi3;
  ena[192] = HAVE_andv4hi3;
  ena[193] = HAVE_andv2si3;
  ena[194] = HAVE_andv16qi3;
  ena[195] = HAVE_andv8hi3;
  ena[196] = HAVE_andv4si3;
  ena[197] = HAVE_andv2di3;
  ena[198] = HAVE_iorsi3;
  ena[199] = HAVE_iordi3;
  ena[200] = HAVE_iorv8qi3;
  ena[201] = HAVE_iorv4hi3;
  ena[202] = HAVE_iorv2si3;
  ena[203] = HAVE_iorv16qi3;
  ena[204] = HAVE_iorv8hi3;
  ena[205] = HAVE_iorv4si3;
  ena[206] = HAVE_iorv2di3;
  ena[207] = HAVE_xorsi3;
  ena[208] = HAVE_xordi3;
  ena[209] = HAVE_xorv8qi3;
  ena[210] = HAVE_xorv4hi3;
  ena[211] = HAVE_xorv2si3;
  ena[212] = HAVE_xorv16qi3;
  ena[213] = HAVE_xorv8hi3;
  ena[214] = HAVE_xorv4si3;
  ena[215] = HAVE_xorv2di3;
  ena[216] = HAVE_ashlqi3;
  ena[217] = HAVE_ashlhi3;
  ena[218] = HAVE_ashlsi3;
  ena[219] = HAVE_ashldi3;
  ena[220] = HAVE_ashlv8qi3;
  ena[221] = HAVE_ashlv4hi3;
  ena[222] = HAVE_ashlv2si3;
  ena[223] = HAVE_ashlv16qi3;
  ena[224] = HAVE_ashlv8hi3;
  ena[225] = HAVE_ashlv4si3;
  ena[226] = HAVE_ashlv2di3;
  ena[227] = HAVE_ashrsi3;
  ena[228] = HAVE_ashrdi3;
  ena[229] = HAVE_ashrv8qi3;
  ena[230] = HAVE_ashrv4hi3;
  ena[231] = HAVE_ashrv2si3;
  ena[232] = HAVE_ashrv16qi3;
  ena[233] = HAVE_ashrv8hi3;
  ena[234] = HAVE_ashrv4si3;
  ena[235] = HAVE_ashrv2di3;
  ena[236] = HAVE_lshrsi3;
  ena[237] = HAVE_lshrdi3;
  ena[238] = HAVE_lshrv8qi3;
  ena[239] = HAVE_lshrv4hi3;
  ena[240] = HAVE_lshrv2si3;
  ena[241] = HAVE_lshrv16qi3;
  ena[242] = HAVE_lshrv8hi3;
  ena[243] = HAVE_lshrv4si3;
  ena[244] = HAVE_lshrv2di3;
  ena[245] = HAVE_rotlsi3;
  ena[246] = HAVE_rotldi3;
  ena[247] = HAVE_rotrsi3;
  ena[248] = HAVE_rotrdi3;
  ena[249] = HAVE_vashlv8qi3;
  ena[250] = HAVE_vashlv4hi3;
  ena[251] = HAVE_vashlv2si3;
  ena[252] = HAVE_vashlv16qi3;
  ena[253] = HAVE_vashlv8hi3;
  ena[254] = HAVE_vashlv4si3;
  ena[255] = HAVE_vashlv2di3;
  ena[256] = HAVE_vashrv8qi3;
  ena[257] = HAVE_vashrv4hi3;
  ena[258] = HAVE_vashrv2si3;
  ena[259] = HAVE_vashrv16qi3;
  ena[260] = HAVE_vashrv8hi3;
  ena[261] = HAVE_vashrv4si3;
  ena[262] = HAVE_vlshrv8qi3;
  ena[263] = HAVE_vlshrv4hi3;
  ena[264] = HAVE_vlshrv2si3;
  ena[265] = HAVE_vlshrv16qi3;
  ena[266] = HAVE_vlshrv8hi3;
  ena[267] = HAVE_vlshrv4si3;
  ena[268] = HAVE_sminsf3;
  ena[269] = HAVE_smindf3;
  ena[270] = HAVE_sminv8qi3;
  ena[271] = HAVE_sminv4hi3;
  ena[272] = HAVE_sminv2si3;
  ena[273] = HAVE_sminv16qi3;
  ena[274] = HAVE_sminv8hi3;
  ena[275] = HAVE_sminv4si3;
  ena[276] = HAVE_sminv2di3;
  ena[277] = HAVE_sminv2sf3;
  ena[278] = HAVE_sminv4sf3;
  ena[279] = HAVE_sminv2df3;
  ena[280] = HAVE_smaxsf3;
  ena[281] = HAVE_smaxdf3;
  ena[282] = HAVE_smaxv8qi3;
  ena[283] = HAVE_smaxv4hi3;
  ena[284] = HAVE_smaxv2si3;
  ena[285] = HAVE_smaxv16qi3;
  ena[286] = HAVE_smaxv8hi3;
  ena[287] = HAVE_smaxv4si3;
  ena[288] = HAVE_smaxv2di3;
  ena[289] = HAVE_smaxv2sf3;
  ena[290] = HAVE_smaxv4sf3;
  ena[291] = HAVE_smaxv2df3;
  ena[292] = HAVE_uminv8qi3;
  ena[293] = HAVE_uminv4hi3;
  ena[294] = HAVE_uminv2si3;
  ena[295] = HAVE_uminv16qi3;
  ena[296] = HAVE_uminv8hi3;
  ena[297] = HAVE_uminv4si3;
  ena[298] = HAVE_uminv2di3;
  ena[299] = HAVE_umaxv8qi3;
  ena[300] = HAVE_umaxv4hi3;
  ena[301] = HAVE_umaxv2si3;
  ena[302] = HAVE_umaxv16qi3;
  ena[303] = HAVE_umaxv8hi3;
  ena[304] = HAVE_umaxv4si3;
  ena[305] = HAVE_umaxv2di3;
  ena[306] = HAVE_negsi2;
  ena[307] = HAVE_negdi2;
  ena[308] = HAVE_negsf2;
  ena[309] = HAVE_negdf2;
  ena[310] = HAVE_negv8qi2;
  ena[311] = HAVE_negv4hi2;
  ena[312] = HAVE_negv2si2;
  ena[313] = HAVE_negv16qi2;
  ena[314] = HAVE_negv8hi2;
  ena[315] = HAVE_negv4si2;
  ena[316] = HAVE_negv2di2;
  ena[317] = HAVE_negv2sf2;
  ena[318] = HAVE_negv4sf2;
  ena[319] = HAVE_negv2df2;
  ena[320] = HAVE_absdi2;
  ena[321] = HAVE_abssf2;
  ena[322] = HAVE_absdf2;
  ena[323] = HAVE_absv8qi2;
  ena[324] = HAVE_absv4hi2;
  ena[325] = HAVE_absv2si2;
  ena[326] = HAVE_absv16qi2;
  ena[327] = HAVE_absv8hi2;
  ena[328] = HAVE_absv4si2;
  ena[329] = HAVE_absv2di2;
  ena[330] = HAVE_absv2sf2;
  ena[331] = HAVE_absv4sf2;
  ena[332] = HAVE_absv2df2;
  ena[333] = HAVE_one_cmplsi2;
  ena[334] = HAVE_one_cmpldi2;
  ena[335] = HAVE_one_cmplv8qi2;
  ena[336] = HAVE_one_cmplv4hi2;
  ena[337] = HAVE_one_cmplv2si2;
  ena[338] = HAVE_one_cmplv16qi2;
  ena[339] = HAVE_one_cmplv8hi2;
  ena[340] = HAVE_one_cmplv4si2;
  ena[341] = HAVE_one_cmplv2di2;
  ena[342] = HAVE_bswaphi2;
  ena[343] = HAVE_bswapsi2;
  ena[344] = HAVE_bswapdi2;
  ena[345] = HAVE_bswapv4hi2;
  ena[346] = HAVE_bswapv2si2;
  ena[347] = HAVE_bswapv8hi2;
  ena[348] = HAVE_bswapv4si2;
  ena[349] = HAVE_bswapv2di2;
  ena[350] = HAVE_ffssi2;
  ena[351] = HAVE_ffsdi2;
  ena[352] = HAVE_clzsi2;
  ena[353] = HAVE_clzdi2;
  ena[354] = HAVE_clzv8qi2;
  ena[355] = HAVE_clzv4hi2;
  ena[356] = HAVE_clzv2si2;
  ena[357] = HAVE_clzv16qi2;
  ena[358] = HAVE_clzv8hi2;
  ena[359] = HAVE_clzv4si2;
  ena[360] = HAVE_ctzsi2;
  ena[361] = HAVE_ctzdi2;
  ena[362] = HAVE_ctzv2si2;
  ena[363] = HAVE_ctzv4si2;
  ena[364] = HAVE_clrsbsi2;
  ena[365] = HAVE_clrsbdi2;
  ena[366] = HAVE_clrsbv8qi2;
  ena[367] = HAVE_clrsbv4hi2;
  ena[368] = HAVE_clrsbv2si2;
  ena[369] = HAVE_clrsbv16qi2;
  ena[370] = HAVE_clrsbv8hi2;
  ena[371] = HAVE_clrsbv4si2;
  ena[372] = HAVE_popcountv8qi2;
  ena[373] = HAVE_popcountv16qi2;
  ena[374] = HAVE_sqrtsf2;
  ena[375] = HAVE_sqrtdf2;
  ena[376] = HAVE_sqrtv2sf2;
  ena[377] = HAVE_sqrtv4sf2;
  ena[378] = HAVE_sqrtv2df2;
  ena[379] = HAVE_movqi;
  ena[380] = HAVE_movhi;
  ena[381] = HAVE_movsi;
  ena[382] = HAVE_movdi;
  ena[383] = HAVE_movti;
  ena[384] = HAVE_movoi;
  ena[385] = HAVE_movci;
  ena[386] = HAVE_movxi;
  ena[387] = HAVE_movsf;
  ena[388] = HAVE_movdf;
  ena[389] = HAVE_movtf;
  ena[390] = HAVE_movv8qi;
  ena[391] = HAVE_movv4hi;
  ena[392] = HAVE_movv2si;
  ena[393] = HAVE_movv16qi;
  ena[394] = HAVE_movv8hi;
  ena[395] = HAVE_movv4si;
  ena[396] = HAVE_movv2di;
  ena[397] = HAVE_movv2sf;
  ena[398] = HAVE_movv4sf;
  ena[399] = HAVE_movv2df;
  ena[400] = HAVE_movmisalignv8qi;
  ena[401] = HAVE_movmisalignv4hi;
  ena[402] = HAVE_movmisalignv2si;
  ena[403] = HAVE_movmisalignv16qi;
  ena[404] = HAVE_movmisalignv8hi;
  ena[405] = HAVE_movmisalignv4si;
  ena[406] = HAVE_movmisalignv2di;
  ena[407] = HAVE_movmisalignv2sf;
  ena[408] = HAVE_movmisalignv4sf;
  ena[409] = HAVE_movmisalignv2df;
  ena[410] = HAVE_insvsi;
  ena[411] = HAVE_insvdi;
  ena[412] = HAVE_cbranchcc4;
  ena[413] = HAVE_cbranchsi4;
  ena[414] = HAVE_cbranchdi4;
  ena[415] = HAVE_cbranchsf4;
  ena[416] = HAVE_cbranchdf4;
  ena[417] = HAVE_movqicc;
  ena[418] = HAVE_movhicc;
  ena[419] = HAVE_movsicc;
  ena[420] = HAVE_movdicc;
  ena[421] = HAVE_movsfcc;
  ena[422] = HAVE_movdfcc;
  ena[423] = HAVE_cmovsi6;
  ena[424] = HAVE_cmovdi6;
  ena[425] = HAVE_cmovsf6;
  ena[426] = HAVE_cmovdf6;
  ena[427] = HAVE_cstorecc4;
  ena[428] = HAVE_cstoresi4;
  ena[429] = HAVE_cstoredi4;
  ena[430] = HAVE_cstoresf4;
  ena[431] = HAVE_cstoredf4;
  ena[432] = HAVE_smuldi3_highpart;
  ena[433] = HAVE_umuldi3_highpart;
  ena[434] = HAVE_movmemdi;
  ena[435] = HAVE_fmasf4;
  ena[436] = HAVE_fmadf4;
  ena[437] = HAVE_fmav2sf4;
  ena[438] = HAVE_fmav4sf4;
  ena[439] = HAVE_fmav2df4;
  ena[440] = HAVE_fmssf4;
  ena[441] = HAVE_fmsdf4;
  ena[442] = HAVE_fnmasf4;
  ena[443] = HAVE_fnmadf4;
  ena[444] = HAVE_fnmav2sf4;
  ena[445] = HAVE_fnmav4sf4;
  ena[446] = HAVE_fnmav2df4;
  ena[447] = HAVE_fnmssf4;
  ena[448] = HAVE_fnmsdf4;
  ena[449] = HAVE_rintsf2;
  ena[450] = HAVE_rintdf2;
  ena[451] = HAVE_rintv2sf2;
  ena[452] = HAVE_rintv4sf2;
  ena[453] = HAVE_rintv2df2;
  ena[454] = HAVE_roundsf2;
  ena[455] = HAVE_rounddf2;
  ena[456] = HAVE_roundv2sf2;
  ena[457] = HAVE_roundv4sf2;
  ena[458] = HAVE_roundv2df2;
  ena[459] = HAVE_floorsf2;
  ena[460] = HAVE_floordf2;
  ena[461] = HAVE_floorv2sf2;
  ena[462] = HAVE_floorv4sf2;
  ena[463] = HAVE_floorv2df2;
  ena[464] = HAVE_ceilsf2;
  ena[465] = HAVE_ceildf2;
  ena[466] = HAVE_ceilv2sf2;
  ena[467] = HAVE_ceilv4sf2;
  ena[468] = HAVE_ceilv2df2;
  ena[469] = HAVE_btruncsf2;
  ena[470] = HAVE_btruncdf2;
  ena[471] = HAVE_btruncv2sf2;
  ena[472] = HAVE_btruncv4sf2;
  ena[473] = HAVE_btruncv2df2;
  ena[474] = HAVE_nearbyintsf2;
  ena[475] = HAVE_nearbyintdf2;
  ena[476] = HAVE_nearbyintv2sf2;
  ena[477] = HAVE_nearbyintv4sf2;
  ena[478] = HAVE_nearbyintv2df2;
  ena[479] = HAVE_reduc_smax_scal_v8qi;
  ena[480] = HAVE_reduc_smax_scal_v4hi;
  ena[481] = HAVE_reduc_smax_scal_v2si;
  ena[482] = HAVE_reduc_smax_scal_v16qi;
  ena[483] = HAVE_reduc_smax_scal_v8hi;
  ena[484] = HAVE_reduc_smax_scal_v4si;
  ena[485] = HAVE_reduc_smax_scal_v2sf;
  ena[486] = HAVE_reduc_smax_scal_v4sf;
  ena[487] = HAVE_reduc_smax_scal_v2df;
  ena[488] = HAVE_reduc_smin_scal_v8qi;
  ena[489] = HAVE_reduc_smin_scal_v4hi;
  ena[490] = HAVE_reduc_smin_scal_v2si;
  ena[491] = HAVE_reduc_smin_scal_v16qi;
  ena[492] = HAVE_reduc_smin_scal_v8hi;
  ena[493] = HAVE_reduc_smin_scal_v4si;
  ena[494] = HAVE_reduc_smin_scal_v2sf;
  ena[495] = HAVE_reduc_smin_scal_v4sf;
  ena[496] = HAVE_reduc_smin_scal_v2df;
  ena[497] = HAVE_reduc_plus_scal_v8qi;
  ena[498] = HAVE_reduc_plus_scal_v4hi;
  ena[499] = HAVE_reduc_plus_scal_v2si;
  ena[500] = HAVE_reduc_plus_scal_v16qi;
  ena[501] = HAVE_reduc_plus_scal_v8hi;
  ena[502] = HAVE_reduc_plus_scal_v4si;
  ena[503] = HAVE_reduc_plus_scal_v2di;
  ena[504] = HAVE_reduc_plus_scal_v2sf;
  ena[505] = HAVE_reduc_plus_scal_v4sf;
  ena[506] = HAVE_reduc_plus_scal_v2df;
  ena[507] = HAVE_reduc_umax_scal_v8qi;
  ena[508] = HAVE_reduc_umax_scal_v4hi;
  ena[509] = HAVE_reduc_umax_scal_v2si;
  ena[510] = HAVE_reduc_umax_scal_v16qi;
  ena[511] = HAVE_reduc_umax_scal_v8hi;
  ena[512] = HAVE_reduc_umax_scal_v4si;
  ena[513] = HAVE_reduc_umin_scal_v8qi;
  ena[514] = HAVE_reduc_umin_scal_v4hi;
  ena[515] = HAVE_reduc_umin_scal_v2si;
  ena[516] = HAVE_reduc_umin_scal_v16qi;
  ena[517] = HAVE_reduc_umin_scal_v8hi;
  ena[518] = HAVE_reduc_umin_scal_v4si;
  ena[519] = HAVE_vec_extractv8qi;
  ena[520] = HAVE_vec_extractv4hi;
  ena[521] = HAVE_vec_extractv2si;
  ena[522] = HAVE_vec_extractv16qi;
  ena[523] = HAVE_vec_extractv8hi;
  ena[524] = HAVE_vec_extractv4si;
  ena[525] = HAVE_vec_extractv2di;
  ena[526] = HAVE_vec_extractv2sf;
  ena[527] = HAVE_vec_extractv4sf;
  ena[528] = HAVE_vec_extractv2df;
  ena[529] = HAVE_vec_initv8qi;
  ena[530] = HAVE_vec_initv4hi;
  ena[531] = HAVE_vec_initv2si;
  ena[532] = HAVE_vec_initv16qi;
  ena[533] = HAVE_vec_initv8hi;
  ena[534] = HAVE_vec_initv4si;
  ena[535] = HAVE_vec_initv2di;
  ena[536] = HAVE_vec_initv2sf;
  ena[537] = HAVE_vec_initv4sf;
  ena[538] = HAVE_vec_initv2df;
  ena[539] = HAVE_vec_pack_trunc_di;
  ena[540] = HAVE_vec_pack_trunc_df;
  ena[541] = HAVE_vec_pack_trunc_v4hi;
  ena[542] = HAVE_vec_pack_trunc_v2si;
  ena[543] = HAVE_vec_pack_trunc_v8hi;
  ena[544] = HAVE_vec_pack_trunc_v4si;
  ena[545] = HAVE_vec_pack_trunc_v2di;
  ena[546] = HAVE_vec_pack_trunc_v2df;
  ena[547] = HAVE_vec_perm_constv8qi;
  ena[548] = HAVE_vec_perm_constv4hi;
  ena[549] = HAVE_vec_perm_constv2si;
  ena[550] = HAVE_vec_perm_constv16qi;
  ena[551] = HAVE_vec_perm_constv8hi;
  ena[552] = HAVE_vec_perm_constv4si;
  ena[553] = HAVE_vec_perm_constv2di;
  ena[554] = HAVE_vec_perm_constv2sf;
  ena[555] = HAVE_vec_perm_constv4sf;
  ena[556] = HAVE_vec_perm_constv2df;
  ena[557] = HAVE_vec_permv8qi;
  ena[558] = HAVE_vec_permv16qi;
  ena[559] = HAVE_vec_setv8qi;
  ena[560] = HAVE_vec_setv4hi;
  ena[561] = HAVE_vec_setv2si;
  ena[562] = HAVE_vec_setv16qi;
  ena[563] = HAVE_vec_setv8hi;
  ena[564] = HAVE_vec_setv4si;
  ena[565] = HAVE_vec_setv2di;
  ena[566] = HAVE_vec_setv2sf;
  ena[567] = HAVE_vec_setv4sf;
  ena[568] = HAVE_vec_setv2df;
  ena[569] = HAVE_vec_shr_v8qi;
  ena[570] = HAVE_vec_shr_v4hi;
  ena[571] = HAVE_vec_shr_v2si;
  ena[572] = HAVE_vec_shr_v2sf;
  ena[573] = HAVE_vec_unpacks_hi_v16qi;
  ena[574] = HAVE_vec_unpacks_hi_v8hi;
  ena[575] = HAVE_vec_unpacks_hi_v4si;
  ena[576] = HAVE_vec_unpacks_hi_v4sf;
  ena[577] = HAVE_vec_unpacks_lo_v16qi;
  ena[578] = HAVE_vec_unpacks_lo_v8hi;
  ena[579] = HAVE_vec_unpacks_lo_v4si;
  ena[580] = HAVE_vec_unpacks_lo_v4sf;
  ena[581] = HAVE_vec_unpacku_hi_v16qi;
  ena[582] = HAVE_vec_unpacku_hi_v8hi;
  ena[583] = HAVE_vec_unpacku_hi_v4si;
  ena[584] = HAVE_vec_unpacku_lo_v16qi;
  ena[585] = HAVE_vec_unpacku_lo_v8hi;
  ena[586] = HAVE_vec_unpacku_lo_v4si;
  ena[587] = HAVE_vec_widen_smult_hi_v16qi;
  ena[588] = HAVE_vec_widen_smult_hi_v8hi;
  ena[589] = HAVE_vec_widen_smult_hi_v4si;
  ena[590] = HAVE_vec_widen_smult_lo_v16qi;
  ena[591] = HAVE_vec_widen_smult_lo_v8hi;
  ena[592] = HAVE_vec_widen_smult_lo_v4si;
  ena[593] = HAVE_vec_widen_umult_hi_v16qi;
  ena[594] = HAVE_vec_widen_umult_hi_v8hi;
  ena[595] = HAVE_vec_widen_umult_hi_v4si;
  ena[596] = HAVE_vec_widen_umult_lo_v16qi;
  ena[597] = HAVE_vec_widen_umult_lo_v8hi;
  ena[598] = HAVE_vec_widen_umult_lo_v4si;
  ena[599] = HAVE_atomic_add_fetchqi;
  ena[600] = HAVE_atomic_add_fetchhi;
  ena[601] = HAVE_atomic_add_fetchsi;
  ena[602] = HAVE_atomic_add_fetchdi;
  ena[603] = HAVE_atomic_addqi;
  ena[604] = HAVE_atomic_addhi;
  ena[605] = HAVE_atomic_addsi;
  ena[606] = HAVE_atomic_adddi;
  ena[607] = HAVE_atomic_and_fetchqi;
  ena[608] = HAVE_atomic_and_fetchhi;
  ena[609] = HAVE_atomic_and_fetchsi;
  ena[610] = HAVE_atomic_and_fetchdi;
  ena[611] = HAVE_atomic_andqi;
  ena[612] = HAVE_atomic_andhi;
  ena[613] = HAVE_atomic_andsi;
  ena[614] = HAVE_atomic_anddi;
  ena[615] = HAVE_atomic_compare_and_swapqi;
  ena[616] = HAVE_atomic_compare_and_swaphi;
  ena[617] = HAVE_atomic_compare_and_swapsi;
  ena[618] = HAVE_atomic_compare_and_swapdi;
  ena[619] = HAVE_atomic_exchangeqi;
  ena[620] = HAVE_atomic_exchangehi;
  ena[621] = HAVE_atomic_exchangesi;
  ena[622] = HAVE_atomic_exchangedi;
  ena[623] = HAVE_atomic_fetch_addqi;
  ena[624] = HAVE_atomic_fetch_addhi;
  ena[625] = HAVE_atomic_fetch_addsi;
  ena[626] = HAVE_atomic_fetch_adddi;
  ena[627] = HAVE_atomic_fetch_andqi;
  ena[628] = HAVE_atomic_fetch_andhi;
  ena[629] = HAVE_atomic_fetch_andsi;
  ena[630] = HAVE_atomic_fetch_anddi;
  ena[631] = HAVE_atomic_fetch_nandqi;
  ena[632] = HAVE_atomic_fetch_nandhi;
  ena[633] = HAVE_atomic_fetch_nandsi;
  ena[634] = HAVE_atomic_fetch_nanddi;
  ena[635] = HAVE_atomic_fetch_orqi;
  ena[636] = HAVE_atomic_fetch_orhi;
  ena[637] = HAVE_atomic_fetch_orsi;
  ena[638] = HAVE_atomic_fetch_ordi;
  ena[639] = HAVE_atomic_fetch_subqi;
  ena[640] = HAVE_atomic_fetch_subhi;
  ena[641] = HAVE_atomic_fetch_subsi;
  ena[642] = HAVE_atomic_fetch_subdi;
  ena[643] = HAVE_atomic_fetch_xorqi;
  ena[644] = HAVE_atomic_fetch_xorhi;
  ena[645] = HAVE_atomic_fetch_xorsi;
  ena[646] = HAVE_atomic_fetch_xordi;
  ena[647] = HAVE_atomic_loadqi;
  ena[648] = HAVE_atomic_loadhi;
  ena[649] = HAVE_atomic_loadsi;
  ena[650] = HAVE_atomic_loaddi;
  ena[651] = HAVE_atomic_nand_fetchqi;
  ena[652] = HAVE_atomic_nand_fetchhi;
  ena[653] = HAVE_atomic_nand_fetchsi;
  ena[654] = HAVE_atomic_nand_fetchdi;
  ena[655] = HAVE_atomic_nandqi;
  ena[656] = HAVE_atomic_nandhi;
  ena[657] = HAVE_atomic_nandsi;
  ena[658] = HAVE_atomic_nanddi;
  ena[659] = HAVE_atomic_or_fetchqi;
  ena[660] = HAVE_atomic_or_fetchhi;
  ena[661] = HAVE_atomic_or_fetchsi;
  ena[662] = HAVE_atomic_or_fetchdi;
  ena[663] = HAVE_atomic_orqi;
  ena[664] = HAVE_atomic_orhi;
  ena[665] = HAVE_atomic_orsi;
  ena[666] = HAVE_atomic_ordi;
  ena[667] = HAVE_atomic_storeqi;
  ena[668] = HAVE_atomic_storehi;
  ena[669] = HAVE_atomic_storesi;
  ena[670] = HAVE_atomic_storedi;
  ena[671] = HAVE_atomic_sub_fetchqi;
  ena[672] = HAVE_atomic_sub_fetchhi;
  ena[673] = HAVE_atomic_sub_fetchsi;
  ena[674] = HAVE_atomic_sub_fetchdi;
  ena[675] = HAVE_atomic_subqi;
  ena[676] = HAVE_atomic_subhi;
  ena[677] = HAVE_atomic_subsi;
  ena[678] = HAVE_atomic_subdi;
  ena[679] = HAVE_atomic_xor_fetchqi;
  ena[680] = HAVE_atomic_xor_fetchhi;
  ena[681] = HAVE_atomic_xor_fetchsi;
  ena[682] = HAVE_atomic_xor_fetchdi;
  ena[683] = HAVE_atomic_xorqi;
  ena[684] = HAVE_atomic_xorhi;
  ena[685] = HAVE_atomic_xorsi;
  ena[686] = HAVE_atomic_xordi;
  ena[687] = HAVE_get_thread_pointerdi;
}

static int
lookup_handler (unsigned scode)
{
  int l = 0, h = ARRAY_SIZE (pats), m;
  while (h > l)
    {
      m = (h + l) / 2;
      if (scode == pats[m].scode)
        return m;
      else if (scode < pats[m].scode)
        h = m;
      else
        l = m + 1;
    }
  return -1;
}

enum insn_code
raw_optab_handler (unsigned scode)
{
  int i = lookup_handler (scode);
  return (i >= 0 && this_fn_optabs->pat_enable[i]
          ? pats[i].icode : CODE_FOR_nothing);
}

bool
swap_optab_enable (optab op, machine_mode m, bool set)
{
  unsigned scode = (op << 16) | m;
  int i = lookup_handler (scode);
  if (i >= 0)
    {
      bool ret = this_fn_optabs->pat_enable[i];
      this_fn_optabs->pat_enable[i] = set;
      return ret;
    }
  else
    {
      gcc_assert (!set);
      return false;
    }
}

const struct convert_optab_libcall_d convlib_def[NUM_CONVLIB_OPTABS] = {
  { "extend", gen_extend_conv_libfunc },
  { "trunc", gen_trunc_conv_libfunc },
  { NULL, NULL },
  { "fix", gen_fp_to_int_conv_libfunc },
  { "fixuns", gen_fp_to_int_conv_libfunc },
  { "float", gen_int_to_fp_conv_libfunc },
  { NULL, gen_ufloat_conv_libfunc },
  { "lrint", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lround", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lfloor", gen_int_to_fp_nondecimal_conv_libfunc },
  { "lceil", gen_int_to_fp_nondecimal_conv_libfunc },
  { "fract", gen_fract_conv_libfunc },
  { "fractuns", gen_fractuns_conv_libfunc },
  { "satfract", gen_satfract_conv_libfunc },
  { "satfractuns", gen_satfractuns_conv_libfunc },
};

const struct optab_libcall_d normlib_def[NUM_NORMLIB_OPTABS] = {
  { '3', "add", gen_int_fp_fixed_libfunc },
  { '3', "add", gen_intv_fp_libfunc },
  { '3', "ssadd", gen_signed_fixed_libfunc },
  { '3', "usadd", gen_unsigned_fixed_libfunc },
  { '3', "sub", gen_int_fp_fixed_libfunc },
  { '3', "sub", gen_intv_fp_libfunc },
  { '3', "sssub", gen_signed_fixed_libfunc },
  { '3', "ussub", gen_unsigned_fixed_libfunc },
  { '3', "mul", gen_int_fp_fixed_libfunc },
  { '3', "mul", gen_intv_fp_libfunc },
  { '3', "ssmul", gen_signed_fixed_libfunc },
  { '3', "usmul", gen_unsigned_fixed_libfunc },
  { '3', "div", gen_int_fp_signed_fixed_libfunc },
  { '3', "divv", gen_int_libfunc },
  { '3', "ssdiv", gen_signed_fixed_libfunc },
  { '3', "udiv", gen_int_unsigned_fixed_libfunc },
  { '3', "usdiv", gen_unsigned_fixed_libfunc },
  { '4', "divmod", gen_int_libfunc },
  { '4', "udivmod", gen_int_libfunc },
  { '3', "mod", gen_int_libfunc },
  { '3', "umod", gen_int_libfunc },
  { '2', "ftrunc", gen_fp_libfunc },
  { '3', "and", gen_int_libfunc },
  { '3', "ior", gen_int_libfunc },
  { '3', "xor", gen_int_libfunc },
  { '3', "ashl", gen_int_fixed_libfunc },
  { '3', "ssashl", gen_signed_fixed_libfunc },
  { '3', "usashl", gen_unsigned_fixed_libfunc },
  { '3', "ashr", gen_int_signed_fixed_libfunc },
  { '3', "lshr", gen_int_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '3', "min", gen_int_fp_libfunc },
  { '3', "max", gen_int_fp_libfunc },
  { '3', "umin", gen_int_libfunc },
  { '3', "umax", gen_int_libfunc },
  { '2', "neg", gen_int_fp_fixed_libfunc },
  { '2', "neg", gen_intv_fp_libfunc },
  { '2', "ssneg", gen_signed_fixed_libfunc },
  { '2', "usneg", gen_unsigned_fixed_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '2', "one_cmpl", gen_int_libfunc },
  { '\0', NULL, NULL },
  { '2', "ffs", gen_int_libfunc },
  { '2', "clz", gen_int_libfunc },
  { '2', "ctz", gen_int_libfunc },
  { '2', "clrsb", gen_int_libfunc },
  { '2', "popcount", gen_int_libfunc },
  { '2', "parity", gen_int_libfunc },
  { '2', "cmp", gen_int_fp_fixed_libfunc },
  { '2', "ucmp", gen_int_libfunc },
  { '2', "eq", gen_fp_libfunc },
  { '2', "ne", gen_fp_libfunc },
  { '2', "gt", gen_fp_libfunc },
  { '2', "ge", gen_fp_libfunc },
  { '2', "lt", gen_fp_libfunc },
  { '2', "le", gen_fp_libfunc },
  { '2', "unord", gen_fp_libfunc },
  { '2', "powi", gen_fp_libfunc },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
  { '\0', NULL, NULL },
};

enum rtx_code const optab_to_code_[NUM_OPTABS] = {
  UNKNOWN,
  SIGN_EXTEND,
  TRUNCATE,
  ZERO_EXTEND,
  FIX,
  UNSIGNED_FIX,
  FLOAT,
  UNSIGNED_FLOAT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FRACT_CONVERT,
  UNSIGNED_FRACT_CONVERT,
  SAT_FRACT,
  UNSIGNED_SAT_FRACT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  PLUS,
  PLUS,
  SS_PLUS,
  US_PLUS,
  MINUS,
  MINUS,
  SS_MINUS,
  US_MINUS,
  MULT,
  MULT,
  SS_MULT,
  US_MULT,
  DIV,
  DIV,
  SS_DIV,
  UDIV,
  US_DIV,
  UNKNOWN,
  UNKNOWN,
  MOD,
  UMOD,
  UNKNOWN,
  AND,
  IOR,
  XOR,
  ASHIFT,
  SS_ASHIFT,
  US_ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  ASHIFT,
  ASHIFTRT,
  LSHIFTRT,
  ROTATE,
  ROTATERT,
  SMIN,
  SMAX,
  UMIN,
  UMAX,
  NEG,
  NEG,
  SS_NEG,
  US_NEG,
  ABS,
  ABS,
  NOT,
  BSWAP,
  FFS,
  CLZ,
  CTZ,
  CLRSB,
  POPCOUNT,
  PARITY,
  UNKNOWN,
  UNKNOWN,
  EQ,
  NE,
  GT,
  GE,
  LT,
  LE,
  UNORDERED,
  UNKNOWN,
  SQRT,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  SET,
  STRICT_LOW_PART,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  COMPARE,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  FMA,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
  UNKNOWN,
};

const optab code_to_optab_[NUM_RTX_CODE] = {
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  mov_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  movstrict_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  cbranch_optab,
  add_optab,
  sub_optab,
  neg_optab,
  smul_optab,
  ssmul_optab,
  usmul_optab,
  sdiv_optab,
  ssdiv_optab,
  usdiv_optab,
  smod_optab,
  udiv_optab,
  umod_optab,
  and_optab,
  ior_optab,
  xor_optab,
  one_cmpl_optab,
  ashl_optab,
  rotl_optab,
  ashr_optab,
  lshr_optab,
  rotr_optab,
  smin_optab,
  smax_optab,
  umin_optab,
  umax_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ne_optab,
  eq_optab,
  ge_optab,
  gt_optab,
  le_optab,
  lt_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unord_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  abs_optab,
  sqrt_optab,
  bswap_optab,
  ffs_optab,
  clrsb_optab,
  clz_optab,
  ctz_optab,
  popcount_optab,
  parity_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  ssadd_optab,
  usadd_optab,
  sssub_optab,
  ssneg_optab,
  usneg_optab,
  unknown_optab,
  ssashl_optab,
  usashl_optab,
  ussub_optab,
  unknown_optab,
  unknown_optab,
  fma_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
  unknown_optab,
};

